
MODULE OLS_interpolation

IMPLICIT NONE

! Contains Interpolation

CONTAINS

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FUNCTION INTERPOL(XVarI,BOLS)
use variables
IMPLICIT  NONE

double precision, INTENT(IN) :: XVarI(1,dim_SSpace), BOLS(dim_betas,1)
double precision :: XXVar(1,dim_betas)
double precision :: INTERPOL

    XXVar(1,1:dim_SSpace)=XVarI(1,1:dim_SSpace)  
    XXVar(1,12:19)=XVarI(1,1:8)**dble(2) 

    XXVar(1,20)=XVarI(1,1)*XVarI(1,2)
    XXVar(1,21)=XVarI(1,1)*XVarI(1,3)
    XXVar(1,22)=XVarI(1,1)*XVarI(1,4)
    XXVar(1,23)=XVarI(1,1)*XVarI(1,5)
    XXVar(1,24)=XVarI(1,1)*XVarI(1,6)
    XXVar(1,25)=XVarI(1,1)*XVarI(1,7)
    XXVar(1,26)=XVarI(1,1)*XVarI(1,8)
    XXVar(1,27)=XVarI(1,1)*XVarI(1,9)
    XXVar(1,28)=XVarI(1,1)*XVarI(1,10)
    XXVar(1,29)=XVarI(1,1)*XVarI(1,11)
    
    XXVar(1,30)=XVarI(1,2)*XVarI(1,3)
    XXVar(1,31)=XVarI(1,2)*XVarI(1,4)
    XXVar(1,32)=XVarI(1,2)*XVarI(1,5)
    XXVar(1,33)=XVarI(1,2)*XVarI(1,6)
    XXVar(1,34)=XVarI(1,2)*XVarI(1,7)
    XXVar(1,35)=XVarI(1,2)*XVarI(1,8)
    XXVar(1,36)=XVarI(1,2)*XVarI(1,9)
    XXVar(1,37)=XVarI(1,2)*XVarI(1,10)
    XXVar(1,38)=XVarI(1,2)*XVarI(1,11)
    
    XXVar(1,39)=XVarI(1,3)*XVarI(1,4)
    XXVar(1,40)=XVarI(1,3)*XVarI(1,5)
    XXVar(1,41)=XVarI(1,3)*XVarI(1,6)
    XXVar(1,42)=XVarI(1,3)*XVarI(1,7)
    XXVar(1,43)=XVarI(1,3)*XVarI(1,8)
    XXVar(1,44)=XVarI(1,3)*XVarI(1,9)
    XXVar(1,45)=XVarI(1,3)*XVarI(1,10)
    XXVar(1,46)=XVarI(1,3)*XVarI(1,11)
    
    XXVar(1,47)=XVarI(1,4)*XVarI(1,5)
    XXVar(1,48)=XVarI(1,4)*XVarI(1,6)
    XXVar(1,49)=XVarI(1,4)*XVarI(1,7)
    XXVar(1,50)=XVarI(1,4)*XVarI(1,8)
    XXVar(1,51)=XVarI(1,4)*XVarI(1,9)
    XXVar(1,52)=XVarI(1,4)*XVarI(1,10)   
    XXVar(1,53)=XVarI(1,4)*XVarI(1,11)
     
    XXVar(1,54)=XVarI(1,5)*XVarI(1,6)
    XXVar(1,55)=XVarI(1,5)*XVarI(1,7)
    XXVar(1,56)=XVarI(1,5)*XVarI(1,8)
    XXVar(1,57)=XVarI(1,5)*XVarI(1,9)
    XXVar(1,58)=XVarI(1,5)*XVarI(1,10)
    XXVar(1,59)=XVarI(1,5)*XVarI(1,11)
    
    XXVar(1,60)=XVarI(1,6)*XVarI(1,7)
    XXVar(1,61)=XVarI(1,6)*XVarI(1,8)
    XXVar(1,62)=XVarI(1,6)*XVarI(1,9)
    XXVar(1,63)=XVarI(1,6)*XVarI(1,10)
    XXVar(1,64)=XVarI(1,6)*XVarI(1,11)
    
    XXVar(1,65)=XVarI(1,7)*XVarI(1,8)
    XXVar(1,66)=XVarI(1,7)*XVarI(1,9)
    XXVar(1,67)=XVarI(1,7)*XVarI(1,10)
    XXVar(1,68)=XVarI(1,7)*XVarI(1,11)

    XXVar(1,69)=XVarI(1,8)*XVarI(1,9)
    XXVar(1,70)=XVarI(1,8)*XVarI(1,10)
    XXVar(1,71)=XVarI(1,8)*XVarI(1,11)

    XXVar(1,72)=XVarI(1,9)*XVarI(1,10)
    XXVar(1,73)=XVarI(1,9)*XVarI(1,11)
    
    XXVar(1,74)=XVarI(1,10)*XVarI(1,11)
    
    XXVar(1,dim_betas)=1.0d-0

   ! INTERPOL
    INTERPOL=sum(XXVar(1,:)*BOLS(:,1),dim=1)
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

END FUNCTION INTERPOL


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FUNCTION OLS_est(XVarI,Emax,Size_grid)

USE MATRIX
use variables
IMPLICIT  NONE

INTEGER, INTENT(IN) :: Size_grid
double precision, INTENT(IN) :: XVarI(Size_grid,dim_SSpace), Emax(Size_grid,1)
double precision :: XOLS(Size_grid,dim_betas), INVXX(dim_betas,dim_betas), OLS_est(dim_betas,1)


    XOLS(1:Size_grid,1:dim_SSpace)=XVarI(1:Size_grid,1:dim_SSpace) 
    XOLS(1:Size_grid,12:19)=XVarI(1:Size_grid,1:8)**dble(2)        !1(G>7), Progress, and previous enrrolement are dummy variables

    XOLS(1:Size_grid,20)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,2)  ! Interactions
    XOLS(1:Size_grid,21)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,3)
    XOLS(1:Size_grid,22)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,4)
    XOLS(1:Size_grid,23)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,24)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,25)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,26)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,27)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,28)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,29)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,11)

    XOLS(1:Size_grid,30)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,3)
    XOLS(1:Size_grid,31)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,4)
    XOLS(1:Size_grid,32)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,33)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,34)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,35)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,36)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,37)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,38)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,11)

    XOLS(1:Size_grid,39)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,4)
    XOLS(1:Size_grid,40)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,41)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,42)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,43)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,44)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,45)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,46)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,11)
    
    XOLS(1:Size_grid,47)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,48)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,49)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,50)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,51)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,52)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,53)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,11)
   
    XOLS(1:Size_grid,54)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,55)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,56)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,57)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,58)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,59)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,11)
    
    XOLS(1:Size_grid,60)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,61)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,62)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,63)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,64)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,11)
    
    
    XOLS(1:Size_grid,65)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,66)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,67)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,68)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,11)
    
    XOLS(1:Size_grid,69)=XOLS(1:Size_grid,8)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,70)=XOLS(1:Size_grid,8)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,71)=XOLS(1:Size_grid,8)*XOLS(1:Size_grid,11)
 
    XOLS(1:Size_grid,72)=XOLS(1:Size_grid,9)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,73)=XOLS(1:Size_grid,9)*XOLS(1:Size_grid,11)    

    XOLS(1:Size_grid,74)=XOLS(1:Size_grid,10)*XOLS(1:Size_grid,11)
    
    XOLS(1:Size_grid,dim_betas)=1.0d-0  !constant

    INVXX=MATINV(matmul(transpose(XOLS),XOLS))

    OLS_est=matmul(INVXX,matmul(transpose(XOLS),Emax))
END FUNCTION OLS_est

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FUNCTION OLS_est1(XVarI,Emax,Size_grid)

USE MATRIX
use variables
IMPLICIT  NONE

INTEGER, INTENT(IN) :: Size_grid
double precision, INTENT(IN) :: XVarI(Size_grid,dim_SSpace), Emax(Size_grid,1)
double precision :: XOLS(Size_grid,60), INVXX(60,60), OLS_aux(60,1), OLS_est1(dim_betas,1)


    XOLS(1:Size_grid,1:8)=XVarI(1:Size_grid,1:8)
    XOLS(1:Size_grid,9:dim_SSpace-1)=XVarI(1:Size_grid,10:dim_SSpace)
    XOLS(1:Size_grid,11:12)=XVarI(1:Size_grid,1:2)**dble(2)        !Progress and previous enrrolement are dummy variables
    XOLS(1:Size_grid,13:15)=XVarI(1:Size_grid,6:8)**dble(2) 
    
    XOLS(1:Size_grid,16)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,2)  ! Interactions
    XOLS(1:Size_grid,17)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,3)
    XOLS(1:Size_grid,18)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,4)
    XOLS(1:Size_grid,19)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,20)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,21)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,22)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,23)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,24)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,10)

    XOLS(1:Size_grid,25)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,3)
    XOLS(1:Size_grid,26)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,4)
    XOLS(1:Size_grid,27)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,28)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,29)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,30)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,31)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,32)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,10)

    XOLS(1:Size_grid,33)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,34)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,35)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,36)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,37)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,38)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,10)
    
    XOLS(1:Size_grid,39)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,40)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,41)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,42)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,43)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,44)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,10)
    
    XOLS(1:Size_grid,45)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,46)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,47)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,48)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,49)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,10)
    
    XOLS(1:Size_grid,50)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,51)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,52)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,53)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,10)
    
    
    XOLS(1:Size_grid,54)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,55)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,56)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,10)
    
    XOLS(1:Size_grid,57)=XOLS(1:Size_grid,8)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,58)=XOLS(1:Size_grid,8)*XOLS(1:Size_grid,10) 

    XOLS(1:Size_grid,59)=XOLS(1:Size_grid,9)*XOLS(1:Size_grid,10)
    
    XOLS(1:Size_grid,60)=1.0d-0  !constant

    INVXX=MATINV(matmul(transpose(XOLS),XOLS))


    OLS_aux=matmul(INVXX,matmul(transpose(XOLS),Emax))
    OLS_est1=0.0d-0
    OLS_est1(1:8,1)=OLS_aux(1:8,1)
    OLS_est1(10:13,1)=OLS_aux(9:12,1)
    OLS_est1(17:26,1)=OLS_aux(13:22,1)
    OLS_est1(28:35,1)=OLS_aux(23:30,1)
    OLS_est1(37:38,1)=OLS_aux(31:32,1)
    OLS_est1(40:43,1)=OLS_aux(33:36,1)
    OLS_est1(45:50,1)=OLS_aux(37:42,1)
    OLS_est1(52:56,1)=OLS_aux(43:47,1)
    OLS_est1(58:61,1)=OLS_aux(48:51,1)
    OLS_est1(63:65,1)=OLS_aux(52:54,1)
    OLS_est1(67:68,1)=OLS_aux(55:56,1)
    OLS_est1(70:71,1)=OLS_aux(57:58,1)
    OLS_est1(74:75,1)=OLS_aux(59:60,1)


    
END FUNCTION OLS_est1

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FUNCTION OLS_est23(XVarI,Emax,Size_grid)

USE MATRIX
use variables
IMPLICIT  NONE

INTEGER, INTENT(IN) :: Size_grid
double precision, INTENT(IN) :: XVarI(Size_grid,dim_SSpace), Emax(Size_grid,1)
double precision :: XOLS(Size_grid,64), INVXX(64,64), OLS_aux(64,1), OLS_est23(dim_betas,1)


    XOLS(1:Size_grid,1:8)=XVarI(1:Size_grid,1:8)
    XOLS(1:Size_grid,9:dim_SSpace-1)=XVarI(1:Size_grid,10:dim_SSpace)
    XOLS(1:Size_grid,11:18)=XVarI(1:Size_grid,1:8)**dble(2)        !Progress and previous enrrolement are dummy variables
    
    XOLS(1:Size_grid,19)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,2)  ! Interactions
    XOLS(1:Size_grid,20)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,3)
    XOLS(1:Size_grid,21)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,4)
    XOLS(1:Size_grid,22)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,23)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,24)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,25)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,26)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,27)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,10)

    XOLS(1:Size_grid,28)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,3)
    XOLS(1:Size_grid,29)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,4)
    XOLS(1:Size_grid,30)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,31)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,32)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,33)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,34)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,35)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,10)

    XOLS(1:Size_grid,36)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,4)
    XOLS(1:Size_grid,37)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,38)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,39)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,40)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,41)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,42)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,10)
    
    XOLS(1:Size_grid,43)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,44)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,45)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,46)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,47)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,48)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,10)
    
    XOLS(1:Size_grid,49)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,50)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,51)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,52)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,53)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,10)
    
    XOLS(1:Size_grid,54)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,55)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,56)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,57)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,10)
    
    
    XOLS(1:Size_grid,58)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,59)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,60)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,10)
    
    XOLS(1:Size_grid,61)=XOLS(1:Size_grid,8)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,62)=XOLS(1:Size_grid,8)*XOLS(1:Size_grid,10) 

    XOLS(1:Size_grid,63)=XOLS(1:Size_grid,9)*XOLS(1:Size_grid,10)
    
    XOLS(1:Size_grid,64)=1.0d-0  !constant

    INVXX=MATINV(matmul(transpose(XOLS),XOLS))


    OLS_aux=matmul(INVXX,matmul(transpose(XOLS),Emax))
    OLS_est23=0.0d-0
    OLS_est23(1:8,1)=OLS_aux(1:8,1)
    OLS_est23(10:26,1)=OLS_aux(9:25,1)
    OLS_est23(28:35,1)=OLS_aux(26:33,1)
    OLS_est23(37:43,1)=OLS_aux(34:40,1)
    OLS_est23(45:50,1)=OLS_aux(41:46,1)
    OLS_est23(52:56,1)=OLS_aux(47:51,1)
    OLS_est23(58:61,1)=OLS_aux(52:55,1)
    OLS_est23(63:65,1)=OLS_aux(56:58,1)
    OLS_est23(67:68,1)=OLS_aux(59:60,1)
    OLS_est23(70:71,1)=OLS_aux(61:62,1)
    OLS_est23(74:75,1)=OLS_aux(63:64,1)


    
END FUNCTION OLS_est23

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FUNCTION OLS_est4(XVarI,Emax,Size_grid)

USE MATRIX
use variables
IMPLICIT  NONE

INTEGER, INTENT(IN) :: Size_grid
double precision, INTENT(IN) :: XVarI(Size_grid,dim_SSpace), Emax(Size_grid,1)
double precision :: XOLS(Size_grid,dim_betas-1), INVXX(dim_betas-1,dim_betas-1), OLS_aux(dim_betas-1,1), OLS_est4(dim_betas,1)


    XOLS(1:Size_grid,1:dim_SSpace)=XVarI(1:Size_grid,1:dim_SSpace) 
    XOLS(1:Size_grid,12:19)=XVarI(1:Size_grid,1:8)**dble(2)        !1(G>7), Progress, and previous enrrolement are dummy variables

    XOLS(1:Size_grid,20)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,2)  ! Interactions
    XOLS(1:Size_grid,21)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,3)
    XOLS(1:Size_grid,22)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,4)
    XOLS(1:Size_grid,23)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,24)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,25)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,26)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,27)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,28)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,29)=XOLS(1:Size_grid,1)*XOLS(1:Size_grid,11)

    XOLS(1:Size_grid,30)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,3)
    XOLS(1:Size_grid,31)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,4)
    XOLS(1:Size_grid,32)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,33)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,34)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,35)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,36)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,37)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,38)=XOLS(1:Size_grid,2)*XOLS(1:Size_grid,11)

    XOLS(1:Size_grid,39)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,4)
    XOLS(1:Size_grid,40)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,41)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,42)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,43)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,44)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,45)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,46)=XOLS(1:Size_grid,3)*XOLS(1:Size_grid,11)
    
    XOLS(1:Size_grid,47)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,5)
    XOLS(1:Size_grid,48)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,49)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,50)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,51)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,52)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,53)=XOLS(1:Size_grid,4)*XOLS(1:Size_grid,11)
   
    XOLS(1:Size_grid,54)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,6)
    XOLS(1:Size_grid,55)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,56)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,57)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,58)=XOLS(1:Size_grid,5)*XOLS(1:Size_grid,11)
    
    XOLS(1:Size_grid,59)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,7)
    XOLS(1:Size_grid,60)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,61)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,62)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,63)=XOLS(1:Size_grid,6)*XOLS(1:Size_grid,11)
    
    
    XOLS(1:Size_grid,64)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,8)
    XOLS(1:Size_grid,65)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,66)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,67)=XOLS(1:Size_grid,7)*XOLS(1:Size_grid,11)
    
    XOLS(1:Size_grid,68)=XOLS(1:Size_grid,8)*XOLS(1:Size_grid,9)
    XOLS(1:Size_grid,69)=XOLS(1:Size_grid,8)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,70)=XOLS(1:Size_grid,8)*XOLS(1:Size_grid,11)
 
    XOLS(1:Size_grid,71)=XOLS(1:Size_grid,9)*XOLS(1:Size_grid,10)
    XOLS(1:Size_grid,72)=XOLS(1:Size_grid,9)*XOLS(1:Size_grid,11)    

    XOLS(1:Size_grid,73)=XOLS(1:Size_grid,10)*XOLS(1:Size_grid,11)
    
    XOLS(1:Size_grid,dim_betas-1)=1.0d-0  !constant

    INVXX=MATINV(matmul(transpose(XOLS),XOLS))

    OLS_aux=matmul(INVXX,matmul(transpose(XOLS),Emax))
    OLS_est4=0.0d-0
    OLS_est4(1:56,1)=OLS_aux(1:56,1)
    OLS_est4(58:dim_betas,1)=OLS_aux(57:dim_betas-1,1)
    
END FUNCTION OLS_est4

	
END MODULE OLS_interpolation
