subroutine student(id,ksi,copy,A1,trueA,choices,gpas,progs,arrests,jails,newschool)
USE OMP_LIB
use variables
implicit none
integer,intent(in):: id, copy,ksi
double precision,intent(in):: A1(2),trueA
integer,intent(out):: choices(bigT),progs(bigT+1),arrests(bigT),jails(bigT),newschool
double precision,intent(out):: gpas(bigT)
double precision:: EA, VA,newA(2)
integer:: t, bigJ(2),bigG,sch,j,loc,enroll,tt,inactive(bigT)
double precision:: vv(4),denominator,numerator,temp,p_trans_vec(bigS)
double precision:: xx(dim_X),rho,GPA0,temp1
double precision,external::  P_pass,E_GPA,p_normal,numerator_trans,random_normal
DOUBLE precision:: ww(dim_w)
integer:: bigS_loc

xx=X(:,id)
loc=hh_loc(id)
rho=R_arrest(loc)
bigS_loc=N_sch_loc(loc)


choices=0
gpas=-99
progs=0
arrests=0
jails=-99
inactive=0
newschool=-99

!Given EMaxV's that are given in subroutine Emaxs, solve the problem forward to simulate the result*********
t=1

    EA=A1(1)
    VA=A1(2)
    bigJ=0
    bigG=4
    sch=sch0(id)
    progs(1)=1
    enroll=1
    call values_new(t, ksi, id, loc, Ea, Va, bigJ, bigG,sch, enroll, progs(t), vv)
    denominator=sum(dexp(vv),dim=1)
    numerator=0
    do j=1,4
        numerator=numerator+dexp(vv(j))
        if (choices(t)==0.and.shock_choice(t,copy,id)<=numerator/denominator) then
            choices(t)=j
        endif
    enddo
    ! Choices: (e=0,d=0): 1, (e=0,d=1): 2, (e=1,d=0): 3, (e=1,d=1): 4. 
    if(choices(t)>2) then  !enrolled
        GPA0=E_GPA(xx,ksi,W(1:6,sch),trueA,bigG+1,1)
        gpas(t)=GPA0+shock_gpa(t,copy,id)*sigma_gpa
        if(shock_prog(t,copy,id)<=P_pass(W(5,sch),gpas(t),ksi,bigG+1,W(1,sch))) then
           progs(t+1)=1
           bigG=bigG+1
        endif            
        temp1=GPA0-trueA  !f(x,w) part of the GPA, GPA=f(x,w)+a+error
        call updateA(gpas(t)-temp1,EA,VA,newA)
        enroll=1 !next period's state variable
        EA=newA(1)
        VA=newA(2)
    else
        enroll=0
    endif
    if(choices(t)==2.or.choices(t)==4) then !crime 
        if(shock_arrest(t,copy,id)<=rho) then
            arrests(t)=1
            bigJ(1)=bigJ(1)+1
            temp=dble(0)
            do j=0,maxJ
                temp=temp+P_Jtime(bigJ(1),j,t)
                if(shock_jail(t,copy,id)<=temp.and.jails(t)==-99) then
                    jails(t)=j
                    tt=nint(dble(j)/dble(J_perYear))
                    if(tt>=1) inactive(min(t+1,bigT):min(bigT,t+tt))=1 !get the rounded number of years spent in jail.
                endif
            enddo
            bigJ(2)=bigJ(2)+jails(t)
        else
            arrests(t)=0
        endif
    endif
        
            
do t=2,bigT
if(inactive(t)==0) then
    if(bigG==Gstar) then  
     !here it is Gstar, because we are trying to figure out which is the new school, i.e., high school where one has already finished bigG=Gstar (8th grade)
        do j=1,bigS_loc
            p_trans_vec(j)=numerator_trans(xx,WW,W(7:12,Mat_sch_loc(j,loc)),gpas(t-1),ksi)            
        enddo
    	denominator=sum(p_trans_vec(1:bigS_loc),dim=1)
    	numerator=0
    	do j=1,bigS_loc
    	    numerator=numerator+p_trans_vec(j)
    	    if(shock_transit(copy,id)<=numerator/denominator.and.newschool==-99) then
    	        newschool=Mat_sch_loc(j,loc)
    	    endif
    	enddo        
        sch=newschool
    endif
    if(bigG<Gstar) then
        ww=W(1:dim_W,sch)
    else
        ww=W(dim_w+1:dim_w+dim_w, sch)
    endif

    call values_new(t, ksi, id, loc, Ea, Va, bigJ, bigG,sch, enroll, progs(t), vv) 
    denominator=sum(dexp(vv),dim=1)
    numerator=0
    do j=1,4
        numerator=numerator+dexp(vv(j))
        if (choices(t)==0.and.shock_choice(t,copy,id)<=numerator/denominator) then
            choices(t)=j
        endif
    enddo


    ! Choices: (e=0,d=0): 1, (e=0,d=1): 2, (e=1,d=0): 3, (e=1,d=1): 4. 
    if(choices(t)>2) then  !enrolled
        GPA0=E_GPA(xx,ksi,Ww,trueA,bigG+1,progs(t))
        gpas(t)=GPA0+shock_gpa(t,copy,id)*sigma_gpa
       if(shock_prog(t,copy,id)<=P_pass(ww(5),gpas(t),ksi,bigG+1,ww(1))) then
          progs(t+1)=1
          bigG=bigG+1
       endif
       temp1=GPA0-trueA   !f(x,w) part of the GPA, GPA=f(x,w)+a+error
       call updateA(gpas(t)-temp1,EA,VA,newA)
       enroll=1 !next period's state variable
       EA=newA(1)
       VA=newA(2)
    else
        enroll=0
    endif
    if(choices(t)==2.or.choices(t)==4) then !crime 
        if(shock_arrest(t,copy,id)<=rho) then
            arrests(t)=1
            bigJ(1)=bigJ(1)+1
            temp=dble(0)
            do j=0,maxJ
                temp=temp+P_Jtime(bigJ(1),j,t)
                if(shock_jail(t,copy,id)<=temp.and.jails(t)==-99) then
                    jails(t)=j
                    tt=nint(dble(j)/dble(J_perYear))
                    if(tt>=1) inactive(min(t+1,bigT):min(bigT,t+tt))=1 !get the rounded number of years spent in jail.
               endif
            enddo
            bigJ(2)=bigJ(2)+jails(t)
        else
            arrests(t)=0
        endif
    endif
endif
enddo

jails=max(0,jails)

end subroutine student

  
    
    
